Index: src/org/jboss/tools/openshift/express/internal/ui/wizard/ApplicationSelectionDialog.java
===================================================================
--- src/org/jboss/tools/openshift/express/internal/ui/wizard/ApplicationSelectionDialog.java	(revision 40918)
+++ src/org/jboss/tools/openshift/express/internal/ui/wizard/ApplicationSelectionDialog.java	(working copy)
@@ -37,6 +37,7 @@
 import org.eclipse.jface.viewers.StructuredSelection;
 import org.eclipse.jface.viewers.TableViewer;
 import org.eclipse.jface.viewers.TableViewerColumn;
+import org.eclipse.jface.viewers.Viewer;
 import org.eclipse.jface.viewers.ViewerCell;
 import org.eclipse.jface.viewers.ViewerSorter;
 import org.eclipse.jface.wizard.IWizard;
@@ -55,6 +56,7 @@
 import org.jboss.tools.openshift.express.internal.ui.utils.Logger;
 
 import com.openshift.client.IApplication;
+import com.openshift.client.IEmbeddableCartridge;
 
 /**
  * @author Andre Dietisheim
@@ -136,7 +138,18 @@
 						}
 					}
 				}), null);
+		
+		tableViewer.setSorter(new ViewerSorter(){
 
+			@Override
+			public int compare(Viewer viewer, Object e1, Object e2) {
+				if(e1 instanceof IApplication && e2 instanceof IApplication){
+					return ((IApplication)e1).getName().compareTo(((IApplication)e2).getName());
+				}
+				return super.compare(viewer, e1, e2);
+			}
+			
+		});
 		/*Button refreshButton = new Button(dialogArea, SWT.PUSH);
 		refreshButton.setText("R&efresh");
 		GridDataFactory.fillDefaults().align(SWT.RIGHT, SWT.TOP).grab(false, false).hint(80, SWT.DEFAULT)
Index: src/org/jboss/tools/openshift/express/internal/ui/wizard/EmbedCartridgeWizardPage.java
===================================================================
--- src/org/jboss/tools/openshift/express/internal/ui/wizard/EmbedCartridgeWizardPage.java	(revision 40918)
+++ src/org/jboss/tools/openshift/express/internal/ui/wizard/EmbedCartridgeWizardPage.java	(working copy)
@@ -38,7 +38,9 @@
 import org.eclipse.jface.viewers.IElementComparer;
 import org.eclipse.jface.viewers.TableViewer;
 import org.eclipse.jface.viewers.TableViewerColumn;
+import org.eclipse.jface.viewers.Viewer;
 import org.eclipse.jface.viewers.ViewerCell;
+import org.eclipse.jface.viewers.ViewerSorter;
 import org.eclipse.jface.wizard.IWizard;
 import org.eclipse.osgi.util.NLS;
 import org.eclipse.swt.SWT;
@@ -110,6 +112,18 @@
 		CheckboxTableViewer viewer = new CheckboxTableViewer(table);
 		viewer.setComparer(new EqualityComparer());
 		viewer.setContentProvider(new ArrayContentProvider());
+		
+		viewer.setSorter(new ViewerSorter(){
+
+			@Override
+			public int compare(Viewer viewer, Object e1, Object e2) {
+				if(e1 instanceof IEmbeddableCartridge && e2 instanceof IEmbeddableCartridge){
+					return ((IEmbeddableCartridge)e1).getName().compareTo(((IEmbeddableCartridge)e2).getName());
+				}
+				return super.compare(viewer, e1, e2);
+			}
+			
+		});
 
 		createTableColumn("Embeddable Cartridge", 1, new CellLabelProvider() {
 
Index: src/org/jboss/tools/openshift/express/internal/ui/wizard/ApplicationConfigurationWizardPage.java
===================================================================
--- src/org/jboss/tools/openshift/express/internal/ui/wizard/ApplicationConfigurationWizardPage.java	(revision 40918)
+++ src/org/jboss/tools/openshift/express/internal/ui/wizard/ApplicationConfigurationWizardPage.java	(working copy)
@@ -12,6 +12,7 @@
 
 import java.lang.reflect.InvocationTargetException;
 import java.net.SocketTimeoutException;
+import java.util.Arrays;
 import java.util.Collection;
 import java.util.Set;
 
@@ -60,7 +61,9 @@
 import org.eclipse.jface.viewers.IElementComparer;
 import org.eclipse.jface.viewers.TableViewer;
 import org.eclipse.jface.viewers.TableViewerColumn;
+import org.eclipse.jface.viewers.Viewer;
 import org.eclipse.jface.viewers.ViewerCell;
+import org.eclipse.jface.viewers.ViewerSorter;
 import org.eclipse.jface.wizard.IWizard;
 import org.eclipse.jface.wizard.IWizardContainer;
 import org.eclipse.jface.wizard.WizardDialog;
@@ -116,6 +119,7 @@
 	private Group newAppEmbeddableCartridgesGroup;
 	private Button checkAllButton;
 	private Button uncheckAllButton;
+	//private ModifyListener modifyListener;
 
 	public ApplicationConfigurationWizardPage(IWizard wizard, OpenShiftExpressApplicationWizardModel wizardModel) {
 		super("Setup OpenShift Application",
@@ -286,7 +290,7 @@
 				.to(selectedCartridgeModelObservable)
 				.converting(new CartridgeToStringConverter())
 				.in(dbc);
-
+		        
 		final ISWTObservableValue useExistingAppBtnSelection = WidgetProperties.selection().observe(useExistingAppBtn);
 		final NewApplicationNameValidator newApplicationNameValidator =
 				new NewApplicationNameValidator(useExistingAppBtnSelection, applicationNameTextObservable);
@@ -432,6 +436,18 @@
 		TableColumnLayout tableLayout = new TableColumnLayout();
 		tableContainer.setLayout(tableLayout);
 		CheckboxTableViewer viewer = new CheckboxTableViewer(table);
+		
+		viewer.setSorter(new ViewerSorter(){
+
+			@Override
+			public int compare(Viewer viewer, Object e1, Object e2) {
+				if(e1 instanceof IEmbeddableCartridge && e2 instanceof IEmbeddableCartridge){
+					return ((IEmbeddableCartridge)e1).getName().compareTo(((IEmbeddableCartridge)e2).getName());
+				}
+				return super.compare(viewer, e1, e2);
+			}
+			
+		});
 		viewer.setComparer(new EqualityComparer());
 		viewer.setContentProvider(new ArrayContentProvider());
 		viewer.addCheckStateListener(onCartridgeChecked());
@@ -776,6 +792,10 @@
 						// reacting to model changes while wizard runnable is
 						// run. We force another update
 						dbc.updateModels();
+						// sort
+						String[] items = newAppCartridgeCombo.getItems();
+						Arrays.sort(items);
+						newAppCartridgeCombo.setItems(items);
 					}
 				});
 			}