### Eclipse Workspace Patch 1.0
#P installer
Index: src/config/install-pack-regular.xml
===================================================================
--- src/config/install-pack-regular.xml	(revision 9602)
+++ src/config/install-pack-regular.xml	(working copy)
@@ -37,24 +37,24 @@
 				JBoss Enterprise Application Platform
 			</description>
 
-			<fileset dir="@{jbosseap.dist}" targetdir="$INSTALL_PATH/jboss-eap">
+			<fileset dir="@{jbosseap.dist}" targetdir="$INSTALL_PATH/runtimes/jboss-eap">
 			</fileset>
 
 			<!-- https://jira.jboss.org/browse/JBDS-1250 is there a better way to `chmod +x *.sh` ? -->
-			<executable os="unix" targetfile="$INSTALL_PATH/jboss-eap/bin/add-user.sh"/>
-			<executable os="unix" targetfile="$INSTALL_PATH/jboss-eap/bin/appclient.sh"/>
-			<executable os="unix" targetfile="$INSTALL_PATH/jboss-eap/bin/domain.sh"/>
-			<executable os="unix" targetfile="$INSTALL_PATH/jboss-eap/bin/jboss-cli.sh"/>
-			<executable os="unix" targetfile="$INSTALL_PATH/jboss-eap/bin/jconsole.sh"/>
-			<executable os="unix" targetfile="$INSTALL_PATH/jboss-eap/bin/jdr.sh"/>
-			<executable os="unix" targetfile="$INSTALL_PATH/jboss-eap/bin/run.sh"/>
-			<executable os="unix" targetfile="$INSTALL_PATH/jboss-eap/bin/standalone.sh"/>
-			<executable os="unix" targetfile="$INSTALL_PATH/jboss-eap/bin/vault.sh"/>
-			<executable os="unix" targetfile="$INSTALL_PATH/jboss-eap/bin/wsconsume.sh"/>
-			<executable os="unix" targetfile="$INSTALL_PATH/jboss-eap/bin/wsprovide.sh"/>
-			<executable os="unix" targetfile="$INSTALL_PATH/jboss-eap/bin/init.d/jboss-as-standalone.sh"/>
-			<!-- not in EAP 6 <executable targetfile="$INSTALL_PATH/jboss-eap/mod_cluster/demo/client/run-demo.sh" os="unix"/> -->
-			<!-- not in EAP 6 <executable targetfile="$INSTALL_PATH/jboss-eap/seam/seam" os="unix"/> -->
+			<executable os="unix" targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/add-user.sh"/>
+			<executable os="unix" targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/appclient.sh"/>
+			<executable os="unix" targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/domain.sh"/>
+			<executable os="unix" targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/jboss-cli.sh"/>
+			<executable os="unix" targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/jconsole.sh"/>
+			<executable os="unix" targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/jdr.sh"/>
+			<executable os="unix" targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/run.sh"/>
+			<executable os="unix" targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/standalone.sh"/>
+			<executable os="unix" targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/vault.sh"/>
+			<executable os="unix" targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/wsconsume.sh"/>
+			<executable os="unix" targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/wsprovide.sh"/>
+			<executable os="unix" targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/init.d/jboss-as-standalone.sh"/>
+			<!-- not in EAP 6 <executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/mod_cluster/demo/client/run-demo.sh" os="unix"/> -->
+			<!-- not in EAP 6 <executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/seam/seam" os="unix"/> -->
 		</pack>
 	</packs>
 </installation>
Index: src/config/install-pack-universal.xml
===================================================================
--- src/config/install-pack-universal.xml	(revision 9602)
+++ src/config/install-pack-universal.xml	(working copy)
@@ -52,21 +52,21 @@
 				JBoss Enterprise Application Platform
 			</description>
 
-			<fileset dir="@{jbosseap.dist}" targetdir="$INSTALL_PATH/jboss-eap/jboss-as">
+			<fileset dir="@{jbosseap.dist}" targetdir="$INSTALL_PATH/runtimes/jboss-eap">
 			</fileset>
 			<!-- https://jira.jboss.org/browse/JBDS-1250 is there a better way to `chmod +x *.sh` ? -->
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/init.d/jboss-as-standalone.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/add-user.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/appclient.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/domain.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/jboss-cli.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/jconsole.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/jdr.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/run.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/standalone.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/vault.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/wsconsume.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/wsprovide.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/init.d/jboss-as-standalone.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/add-user.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/appclient.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/domain.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/jboss-cli.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/jconsole.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/jdr.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/run.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/standalone.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/vault.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/wsconsume.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/wsprovide.sh" os="unix"/>
 		</pack>
 	</packs>
 </installation>
#P devstudio-installer
Index: src/config/install-pack-universal.xml
===================================================================
--- src/config/install-pack-universal.xml	(revision 9602)
+++ src/config/install-pack-universal.xml	(working copy)
@@ -52,21 +52,21 @@
 				JBoss Enterprise Application Platform
 			</description>
 
-			<fileset dir="@{jbosseap.dist}" targetdir="$INSTALL_PATH/jboss-eap/jboss-as">
+			<fileset dir="@{jbosseap.dist}" targetdir="$INSTALL_PATH/runtimes/jboss-eap">
 			</fileset>
 			<!-- https://jira.jboss.org/browse/JBDS-1250 is there a better way to `chmod +x *.sh` ? -->
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/init.d/jboss-as-standalone.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/add-user.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/appclient.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/domain.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/jboss-cli.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/jconsole.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/jdr.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/run.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/standalone.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/vault.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/wsconsume.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/wsprovide.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/init.d/jboss-as-standalone.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/add-user.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/appclient.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/domain.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/jboss-cli.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/jconsole.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/jdr.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/run.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/standalone.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/vault.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/wsconsume.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/wsprovide.sh" os="unix"/>
 		</pack>
 	</packs>
 </installation>
Index: src/config/install-pack-regular.xml
===================================================================
--- src/config/install-pack-regular.xml	(revision 9602)
+++ src/config/install-pack-regular.xml	(working copy)
@@ -37,21 +37,21 @@
 				JBoss Enterprise Application Platform
 			</description>
 
-			<fileset dir="@{jbosseap.dist}" targetdir="$INSTALL_PATH/jboss-eap/jboss-as">
+			<fileset dir="@{jbosseap.dist}" targetdir="$INSTALL_PATH/runtimes/jboss-eap">
 			</fileset>
 			<!-- https://jira.jboss.org/browse/JBDS-1250 is there a better way to `chmod +x *.sh` ? -->
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/init.d/jboss-as-standalone.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/add-user.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/appclient.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/domain.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/jboss-cli.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/jconsole.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/jdr.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/run.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/standalone.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/vault.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/wsconsume.sh" os="unix"/>
-			<executable targetfile="$INSTALL_PATH/jboss-eap/jboss-as/bin/wsprovide.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/init.d/jboss-as-standalone.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/add-user.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/appclient.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/domain.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/jboss-cli.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/jconsole.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/jdr.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/run.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/standalone.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/vault.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/wsconsume.sh" os="unix"/>
+			<executable targetfile="$INSTALL_PATH/runtimes/jboss-eap/bin/wsprovide.sh" os="unix"/>
 		</pack>
 	</packs>
 </installation>
#P org.jboss.tools.runtime.ui
Index: src/org/jboss/tools/runtime/ui/JBossRuntimeStartup.java
===================================================================
--- src/org/jboss/tools/runtime/ui/JBossRuntimeStartup.java	(revision 41609)
+++ src/org/jboss/tools/runtime/ui/JBossRuntimeStartup.java	(working copy)
@@ -39,7 +39,7 @@
 
 public class JBossRuntimeStartup {
 	
-	private static final String JBOSS_EAP_HOME = "../../jboss-eap"; 	// JBoss EAP home directory (relative to plugin)- <RHDS_HOME>/jbossas. //$NON-NLS-1$
+	private static final String JBOSS_EAP_HOME = "../../runtimes/jboss-eap"; 	// JBoss EAP home directory (relative to plugin)- <RHDS_HOME>/jbossas. //$NON-NLS-1$
 	
 	private static final String LOCATIONS_FILE_NAME = "runtime_locations.properties"; //$NON-NLS-1$
 	private static final String LOCATIONS_FILE = "../../../../studio/" + LOCATIONS_FILE_NAME; //$NON-NLS-1$