Index: product/pom.xml
===================================================================
--- product/pom.xml	(revision 9656)
+++ product/pom.xml	(working copy)
@@ -1,6 +1,5 @@
-<project
-	xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd"
-	xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
+<?xml version="1.0" encoding="UTF-8"?>
+<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
 	<modelVersion>4.0.0</modelVersion>
 	<parent>
 		<groupId>org.jboss.tools</groupId>
@@ -13,6 +12,18 @@
 	<version>0.0.2-SNAPSHOT</version>
 	<name>JBDS - Product, Extras, Tech Preview, Installers</name>
 	<packaging>pom</packaging>
+	<properties>
+		<version.major>5</version.major>
+		<version.minor>0</version.minor>
+		<version.revision>0</version.revision>
+		<version.tag>CR1</version.tag>
+		<version.name />
+		<version.full>5.0.0</version.full>
+		<version.presentstring>5.0.0.CR1</version.presentstring>
+		<build-type>development</build-type>
+		<maven.build.timestamp.format>yyyyMMdd-HHmm</maven.build.timestamp.format>
+		<jbds-build-name>${maven.build.timestamp}</jbds-build-name>
+	</properties>
 	<!--
 	     Build product features, site, and products (including installers) here: 
 
@@ -25,15 +36,6 @@
 	     Generated products are in ../product/features/com.jboss.jbds/target/products/ and can be used simply by unpacking the zip
 	     Installers are in installer/target/ and can be installed using 'java -jar jbdevstudio-*.jar'
 	-->
-	<modules>
-		<module>plugins</module>
-		<module>features</module>
-		<module>site</module>
-		<module>../extras</module>
-		<module>../techpreview</module>
-		<module>installer</module>
-		<module>sources</module>
-	</modules>
 	<repositories>
 		<!-- JBT nightly components -->
 		<repository>
@@ -84,4 +86,3 @@
 		</repository>
 	</repositories>
 </project>
-	
Index: product/site/pom.xml
===================================================================
--- product/site/pom.xml	(revision 9656)
+++ product/site/pom.xml	(working copy)
@@ -9,7 +9,7 @@
 	</parent>
 	<groupId>com.jboss.jbds.site</groupId>
 	<artifactId>com.jboss.jbds.site.product</artifactId>
-	<version>0.0.2-SNAPSHOT</version>
+	<version>5.0.0-SNAPSHOT</version>
 	<packaging>eclipse-repository</packaging>
 
 	<build>
@@ -118,7 +118,7 @@
 					<dependency>
 						<groupId>ant-contrib</groupId>
 						<artifactId>ant-contrib</artifactId>
-						<version>1.0b3</version>
+						<version>1.0b2</version>
 					</dependency>
 				</dependencies>
 			</plugin>
Index: product/sources/pom.xml
===================================================================
--- product/sources/pom.xml	(revision 9676)
+++ product/sources/pom.xml	(working copy)
@@ -7,18 +7,15 @@
 		<artifactId>product</artifactId>
 		<version>0.0.2-SNAPSHOT</version>
 	</parent>
-	<groupId>com.jboss.jbds</groupId>
-	<artifactId>com.jboss.jbds.sources</artifactId>
+	<groupId>com.jboss.jbds.product</groupId>
+	<artifactId>com.jboss.jbds.product.sources</artifactId>
+	<version>5.0.0-SNAPSHOT</version>
 	<name>JBoss Developer Studio Sources</name>
 	<description>
     Aggregates upstream sources zip(s) and local sources into a single JBDS sources zip
 	</description>
 	<packaging>pom</packaging>
 
-	<properties>
-		<maven.build.timestamp.format>yyyyMMdd-HHmm</maven.build.timestamp.format>
-	</properties>
-
 	<build>
 		<plugins>
 			<plugin>
@@ -84,6 +81,27 @@
 					</dependency>
 				</dependencies>
 			</plugin>
+			<plugin>
+				<groupId>org.apache.maven.plugins</groupId>
+				<artifactId>maven-install-plugin</artifactId>
+				<version>2.3.1</version>
+				<executions>
+				<execution>
+							<id>install-sources-zip</id>
+							<phase>install</phase>
+							<goals>
+								<goal>install-file</goal>
+							</goals>
+							<configuration>
+								<groupId>${project.groupId}</groupId>
+								<artifactId>jbdevstudio-product-sources</artifactId>
+								<version>${project.version}</version>
+								<packaging>zip</packaging>
+								<file>${project.build.directory}/jbdevstudio-product-sources-${version.full}.v${maven.build.timestamp}-H${BUILD_NUMBER}-${version.tag}.zip</file>
+							</configuration>
+				</execution>
+				</executions>		
+			</plugin>
 		</plugins>
 	</build>
 
Index: product/pom-all-update-sites.xml
===================================================================
--- product/pom-all-update-sites.xml	(revision 9656)
+++ product/pom-all-update-sites.xml	(working copy)
@@ -3,13 +3,13 @@
 	xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
 	<modelVersion>4.0.0</modelVersion>
 	<parent>
-		<groupId>org.jboss.tools</groupId>
-		<artifactId>parent</artifactId>
-		<version>3.3.0.CR1-SNAPSHOT</version>
-		<relativePath>../build/parent/pom.xml</relativePath>
+		<groupId>com.jboss.jbds</groupId>
+		<artifactId>product</artifactId>
+		<version>0.0.2-SNAPSHOT</version>
+		<relativePath>.</relativePath>
 	</parent>
 	<groupId>com.jboss.jbds</groupId>
-	<artifactId>product</artifactId>
+	<artifactId>product-all</artifactId>
 	<version>0.0.2-SNAPSHOT</version>
 	<name>JBDS - Product, Extras, Tech Preview, Installers</name>
 	<packaging>pom</packaging>
@@ -33,6 +33,7 @@
 		<module>../techpreview</module>
 		<module>installer</module>
 		<module>sources</module>
+		<module>build-results</module>
 	</modules>
 	<repositories>
 		<!-- JBT nightly components -->
Index: product/installer/build-pde.xml
===================================================================
--- product/installer/build-pde.xml	(revision 9656)
+++ product/installer/build-pde.xml	(working copy)
@@ -4,10 +4,6 @@
 <project name="JBDS Installer" default="installer">
 	<taskdef resource="net/sf/antcontrib/antlib.xml" />
 
-	<property file="local.properties" />
-	<property file="version.properties" />
-	<property file="build.properties" />
-
 	<!-- Setup the build timestamp & build identifer properties -->
 	<tstamp>
 		<format property="build.number" pattern="yyyyMMddHHmm" />
Index: product/installer/pom.xml
===================================================================
--- product/installer/pom.xml	(revision 9656)
+++ product/installer/pom.xml	(working copy)
@@ -7,12 +7,11 @@
 		<artifactId>product</artifactId>
 		<version>0.0.2-SNAPSHOT</version>
 	</parent>
-	<groupId>com.jboss.jbds</groupId>
+	<groupId>com.jboss.jbds.product</groupId>
 	<artifactId>universal-installer</artifactId>
+	<name>JBoss Developer Studio Installer</name>
 	<version>5.0.0-SNAPSHOT</version>
 	<packaging>eclipse-repository</packaging>
-	<properties />
-
 	<repositories>
 		<repository>
 			<id>jboss-requirements-composite-extras-mirror</id>
@@ -29,6 +28,7 @@
 
 
 	<build>
+		<finalName>testng-update-${builQualifier}</finalName>
 		<plugins>
 			<plugin>
 				<groupId>org.apache.maven.plugins</groupId>
@@ -89,6 +89,11 @@
 					</execution>
 				</executions>
 			</plugin>
+			<!-- plugin> <groupId>org.codehaus.mojo</groupId> <artifactId>properties-maven-plugin</artifactId> 
+				<version>1.0-alpha-2</version> <configuration> <files> <file>version.properties</file> 
+				</files> </configuration> <executions> <execution> <id>load-version-properties</id> 
+				<phase>install</phase> <goals><goal>read-project-properties</goal></goals> 
+				</execution> </executions> </plugin -->
 			<plugin>
 				<artifactId>maven-antrun-plugin</artifactId>
 				<version>${maven.antrun.plugin.version}</version>
@@ -102,12 +107,14 @@
 						<configuration>
 							<tasks>
 								<taskdef resource="net/sf/antcontrib/antcontrib.properties" />
-								
+
 								<if>
 									<and>
-										<available file="${basedir}/../../requirements" type="dir" />
+										<available file="${basedir}/../../requirements"
+											type="dir" />
 										<available file="requirements.properties" type="file" />
-										<available file="${basedir}/../../requirements/build.xml" type="file" />
+										<available file="${basedir}/../../requirements/build.xml"
+											type="file" />
 									</and>
 									<then>
 										<property file="requirements.properties" />
@@ -128,16 +135,24 @@
 					<execution>
 						<id>install</id>
 						<phase>install</phase>
+						<goals>
+							<goal>run</goal>
+						</goals>
 						<configuration>
 							<quiet>true</quiet>
 							<tasks>
-								<echo>prepare update site zip </echo>
+								<echo>Prepare update site zip </echo>
+								
 								<move todir="${project.build.directory}/testng">
 									<fileset dir="${project.build.directory}/repository" />
 								</move>
-								<zip
-									destfile="${project.build.directory}/jbdevstudio-product-installer-Update-${buildQualifier}.zip"
-									whenempty="fail">
+								
+								<property name="installer-update-location"
+									value="${project.build.directory}/jbdevstudio-product-installer-Update-${version.full}.${buildQualifier}.zip" />
+								<property name="requirements.module"
+								    value="${basedir}/../../requirements" />
+								    
+								<zip destfile="${installer-update-location}" whenempty="fail">
 									<fileset dir="${project.build.directory}" includes="*.xml"
 										excludes="category.xml" />
 									<zipfileset dir="${project.build.directory}/jbds"
@@ -145,29 +160,30 @@
 									<zipfileset dir="${project.build.directory}/testng"
 										prefix="testng" />
 								</zip>
+								
 								<unzip src="${basedir}/IzPack-4.3.4.zip" dest="${project.build.directory}" />
-								<property file="${basedir}/../../requirements/jbeap-6/build.properties" />
-								<echo>${basedir}</echo>
-								<ant antfile="build-pde.xml">
+								<property file="${requirements.module}/jbeap-6/build.properties" />
+
+								<ant antfile="build-pde.xml" inheritAll="true">
 									<property name="pack.name" value="universal" />
 									<property name="platform.name" value="universal" />
 									<property name="artifacts.p2-director" value="${basedir}/p2-director.zip" />
-									<property name="artifacts.jbds.update"
-										value="${project.build.directory}/jbdevstudio-product-installer-Update-${buildQualifier}.zip" />
+									<property name="artifacts.jbds.update" value="${installer-update-location}" />
 									<property name="artifacts.jbosseap"
-										location="${basedir}/../../requirements/download/jbeap-6/${jbeap60.build.archive}" />
+										location="${requirements.module}/download/jbeap-6/${jbeap60.build.archive}" />
 									<property name="destination.dir" value="${project.build.directory}" />
 									<property name="izpack.home"
 										value="${project.build.directory}/IzPack-4.3.4" />
 									<property name="skip.ant.actions" value="true" />
 									<property name="buildQualifier" value="${buildQualifier}" />
 									<property name="product.buildType" value="R" />
+									<property name="version.major" value="${version.major}" />
+									<property name="version.minor" value="${version.minor}" />
+									<property name="version.revision" value="${version.revision}" />
+									<property name="version.presentstring" value="${version.presentstring}" />
 								</ant>
 							</tasks>
 						</configuration>
-						<goals>
-							<goal>run</goal>
-						</goals>
 					</execution>
 				</executions>
 				<dependencies>
@@ -220,6 +236,41 @@
 					</dependency>
 				</dependencies>
 			</plugin>
+			<plugin>
+				<groupId>org.apache.maven.plugins</groupId>
+				<artifactId>maven-install-plugin</artifactId>
+				<version>2.3.1</version>
+				<executions>
+					<execution>
+						<id>install</id>
+						<phase>install</phase>
+						<goals>
+							<goal>install-file</goal>
+						</goals>
+						<configuration>
+							<groupId>${project.groupId}</groupId>
+							<artifactId>jbdevstudio-product-universal</artifactId>
+							<version>${project.version}</version>
+							<packaging>jar</packaging>
+							<file>${project.build.directory}/jbdevstudio-product-universal-${version.major}.${version.minor}.${version.revision}.${buildQualifier}.jar</file>
+						</configuration>
+					</execution>
+					<execution>
+						<id>install-eap</id>
+						<phase>install</phase>
+						<goals>
+							<goal>install-file</goal>
+						</goals>
+						<configuration>
+							<groupId>${project.groupId}</groupId>
+							<artifactId>jbdevstudio-product-eap-universal</artifactId>
+							<version>${project.version}</version>
+							<packaging>jar</packaging>
+							<file>${project.build.directory}/jbdevstudio-product-eap-universal-${version.major}.${version.minor}.${version.revision}.${buildQualifier}.jar</file>
+						</configuration>
+					</execution>
+				</executions>
+			</plugin>
 		</plugins>
 	</build>
 </project>
Index: product/installer/version.properties
===================================================================
--- product/installer/version.properties	(revision 9656)
+++ product/installer/version.properties	(working copy)
@@ -1,31 +0,0 @@
-# remember to update other files to match:
-#    devstudio-installer/version.properties
-#    releng/org.jboss.ide.eclipse.releng/builders/jbds-all-package/jbds-all.product
-#    product/features/com.jboss.jbds/com.jboss.jbds.product
-
-# version information for the installer
-version.major=5
-version.minor=0
-version.revision=0
-version.tag=CR1
-version.name=
-version.presentstring=5.0.0.CR1
-
-# see eclipse/configuration/config.ini
-eclipse.buildId.version=M20111214-1406
-org.eclipse.osgi.version=3.7.2.v20111205-1537
-org.eclipse.equinox.simpleconfigurator.version=1.0.200.v20110815-1438
-
-# see target platform for versions with 
-#  find ~/33x/build/target-platform/REPO -name org.eclipse.equinox.launcher\*
-# also in eclipse/eclipse.ini or eclipse/Eclipse.app/Contents/MacOS/eclipse.ini
-org.eclipse.equinox.launcher.version=1.2.0.v20110502
-org.eclipse.equinox.launcher.gtk.linux.x86.version=1.1.100.v20110505
-org.eclipse.equinox.launcher.gtk.linux.x86_64.version=1.1.100.v20110505
-org.eclipse.equinox.launcher.win32.win32.x86.version=1.1.100.v20110502
-org.eclipse.equinox.launcher.win32.win32.x86_64.version=1.1.100.v20110502
-org.eclipse.equinox.launcher.cocoa.macosx.version=1.1.100.v20110502
-
-#  find ~/33x/build/target-platform/REPO -name org.eclipse.equinox.transforms\*
-org.eclipse.equinox.transforms.xslt.version=1.0.200.v20100503
-org.eclipse.equinox.transforms.hook.version=1.0.300.v20100719
Index: product/installer/build.properties
===================================================================
--- product/installer/build.properties	(revision 9656)
+++ product/installer/build.properties	(working copy)
@@ -1,21 +0,0 @@
-bin.includes = META-INF/
-
-##
-# fileset of plugins to exclude from the eclipse distribution
-##
-exclude.plugins=org.jboss.tools.birt*.jar,\
- org.springframework.ide.eclipse.ajdt*.jar,\
- org.springframework.*source*/**,\
- org.springframework.ide.eclipse.*.mylyn*.jar,\
- org.springframework.ide.eclipse.mylyn*.jar,\
- org.springframework.security*.jar,\
-  org.jboss.tools.flow.jpdl4*.jar,\
- org.jboss.tools.flow.common*.jar
- 
-exclude.features=org.jboss.tools.birt.feature*/**,\
- org.springframework.ide.eclipse.ajdt.feature*/**,\
- org.springframework.*feature.source*/**,\
- org.springframework.ide.eclipse.mylyn.feature*/**,\
- org.jboss.tools.jbpm4.feature*/**,\
- org.jboss.tools.flow.jpdl4.feature*/**,\
- org.jboss.tools.flow.common.feature*/**